SystemOrganization addCategory: #'Seaside-Cache-NG'!

WAError subclass: #WAaximumNumberOfSessionsExceededError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Cache-NG'!

!WAaximumNumberOfSessionsExceededError commentStamp: 'pmm 9/8/2013 17:59' prior: 0!
http://ora-00018.ora-code.com/!

WAObject subclass: #WACacheKeyEntryNG
	instanceVariableNames: 'key keyHash value next byAccessListEntry byCreationListEntry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Cache-NG'!

!WACacheKeyEntryNG methodsFor: 'accessing' stamp: 'pmm 9/8/2013 18:33'!
byAccessListEntry
	^ byAccessListEntry! !

!WACacheKeyEntryNG methodsFor: 'accessing' stamp: 'pmm 9/8/2013 18:33'!
byCreationListEntry
	^ byCreationListEntry! !

!WACacheKeyEntryNG methodsFor: 'accessing' stamp: 'pmm 9/8/2013 18:28'!
key
	^ key! !

!WACacheKeyEntryNG methodsFor: 'accessing' stamp: 'pmm 9/8/2013 18:28'!
value
	^ value! !

WAObject subclass: #WACacheListEntryNG
	instanceVariableNames: 'previous next time cacheEntry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Cache-NG'!

!WACacheListEntryNG methodsFor: 'accessing' stamp: 'pmm 9/8/2013 18:27'!
cacheEntry
	^ cacheEntry! !

!WACacheListEntryNG methodsFor: 'accessing' stamp: 'pmm 9/8/2013 18:17'!
time
	^ time! !

WAObject subclass: #WACacheNG
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Cache-NG'!

!WACacheNG methodsFor: 'accessing' stamp: 'pmm 8/26/2012 12:17'!
at: aKey ifAbsent: aBlock
	self subclassResponsibility! !

!WACacheNG methodsFor: 'putting' stamp: 'pmm 8/26/2012 12:15'!
at: aKey put: anObject
	self subclassResponsibility! !

!WACacheNG methodsFor: 'public' stamp: 'pmm 9/8/2013 17:50'!
clear
	self subclassResponsibility! !

!WACacheNG methodsFor: 'accessing' stamp: 'pmm 8/26/2012 12:19'!
keyAtValue: anObject ifAbsent: aBlock
	self subclassResponsibility! !

!WACacheNG methodsFor: 'enumerating' stamp: 'pmm 8/26/2012 12:04'!
keysAndValuesDo: aTwoArgumentBlock
	self subclassResponsibility! !

!WACacheNG methodsFor: 'removing' stamp: 'pmm 8/26/2012 12:16'!
remove: anObject
	self subclassResponsibility! !

!WACacheNG methodsFor: 'putting' stamp: 'pmm 8/26/2012 12:49'!
store: anObject
	"Store anObject in the cache, generating a new random key. Return the key."
	self subclassResponsibility! !

WACacheNG subclass: #WAHashCacheNG
	instanceVariableNames: 'keyTable valueTable size maximumSize maximumRelativeAge maximumAbsoluteAge overflowAction byAccessRoot byCreationRoot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Cache-NG'!

!WAHashCacheNG class methodsFor: 'accessing' stamp: 'pmm 9/8/2013 18:16'!
overflowActions
	^ Array
		with: self removeRelativeOldest
		with: self removeAbsoluteOldest
		with: self signalError! !

!WAHashCacheNG class methodsFor: 'accessing' stamp: 'pmm 9/8/2013 18:15'!
removeAbsoluteOldest
	^ #removeAbsoluteOldest! !

!WAHashCacheNG class methodsFor: 'accessing' stamp: 'pmm 9/8/2013 18:15'!
removeRelativeOldest
	^ #removeRelativeOldest! !

!WAHashCacheNG class methodsFor: 'accessing' stamp: 'pmm 9/8/2013 18:01'!
signalError
	^ #signalError! !

!WAHashCacheNG methodsFor: 'accessing' stamp: 'pmm 9/8/2013 18:03'!
at: aKey ifAbsent: aBlock
	self notYetImplemented! !

!WAHashCacheNG methodsFor: 'putting' stamp: 'pmm 9/8/2013 18:09'!
at: aKey put: anObject
	self notYetImplemented! !

!WAHashCacheNG methodsFor: 'public' stamp: 'pmm 9/8/2013 18:08'!
clear
	size = 0.
	keyTable atAllPut: nil.
	valueTable atAllPut: nil. 
	byAccessRoot := nil.
	byCreationRoot := nil! !

!WAHashCacheNG methodsFor: 'private' stamp: 'pmm 9/8/2013 18:05'!
includesKey: aKey
	self notYetImplemented! !

!WAHashCacheNG methodsFor: 'accessing' stamp: 'pmm 9/8/2013 18:05'!
keyAtValue: anObject ifAbsent: aBlock
	self notYetImplemented! !

!WAHashCacheNG methodsFor: 'enumerating' stamp: 'pmm 9/8/2013 18:05'!
keysAndValuesDo: aTwoArgumentBlock
	self notYetImplemented! !

!WAHashCacheNG methodsFor: 'private' stamp: 'pmm 9/8/2013 18:01'!
performOverflowAction
	"
	remove oldest
	remove least recently used
	signal error"
	self notYetImplemented! !

!WAHashCacheNG methodsFor: 'removing' stamp: 'pmm 9/8/2013 18:13'!
remove: anObject
	| key |
	key := self keyAtValue: anObject ifAbsent: [ ^ anObject ].
	self removeKey: key! !

!WAHashCacheNG methodsFor: 'private' stamp: 'pmm 9/8/2013 18:30'!
removeFromKeyTable: aKey
	self notYetImplemented! !

!WAHashCacheNG methodsFor: 'private' stamp: 'pmm 9/8/2013 18:30'!
removeFromValueTable: aKey
	self notYetImplemented! !

!WAHashCacheNG methodsFor: 'removing' stamp: 'pmm 9/8/2013 18:11'!
removeKey: aKey
	self notYetImplemented ! !

!WAHashCacheNG methodsFor: 'putting' stamp: 'pmm 8/26/2012 12:53'!
store: anObject
	| candidateKey |
	[ 
		candidateKey := WAKeyGenerator current keyOfLength: self keySize.
		self includesKey: candidateKey ] whileTrue.
	self at: candidateKey put: anObject.
	^ candidateKey! !

!WAHashCacheNG methodsFor: 'private' stamp: 'pmm 9/8/2013 18:35'!
sweep: aListRoot maximumAge: anNumberOfSeconds now: currentSeconds
	| current |
	current := aListRoot.
	current isNil whileFalse: [
		(current time +  anNumberOfSeconds) > currentSeconds
			ifTrue: [
				| cacheEntry byAccessListEntry byCreationListEntry |
				cacheEntry := current cacheEntry.
				self removeFromKeyTable: cacheEntry key.
				self removeFromValueTable: cacheEntry value.
				byAccessListEntry := cacheEntry byAccessListEntry.
				byAccessListEntry == current
					ifTrue: []
					ifFalse: [].
				byCreationListEntry := cacheEntry byCreationListEntry.
				byCreationListEntry == current
					ifTrue: []
					ifFalse: [].
				self notYetImplemented.
				size := size - 1 ]
			ifFalse: [
				"the list is ordered so we can stop scanning"
				^ self ] ]! !

!WAHashCacheNG methodsFor: 'private' stamp: 'pmm 9/8/2013 18:22'!
sweepIncrementally
	| now |
	now := Time totalSeconds.
	maximumAbsoluteAge > 0 ifTrue: [
		self sweep: byCreationRoot maximumAge: maximumAbsoluteAge now: now ].
	
	maximumRelativeAge > 0 ifTrue: [
		self sweep: byAccessRoot maximumAge: maximumRelativeAge now: now ]! !

WACacheNG subclass: #WAMutualExclusionCacheNG
	instanceVariableNames: 'mutex cache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Cache-NG'!

!WAMutualExclusionCacheNG class methodsFor: 'instance creation' stamp: 'pmm 8/26/2012 12:08'!
on: aCache
	^ self basicNew initializeOn: aCache; yourself! !

!WAMutualExclusionCacheNG methodsFor: 'accessing' stamp: 'pmm 9/8/2013 17:48'!
at: aKey ifAbsent: aBlock
	^ mutex critical: [
		cache at: aKey ifAbsent: aBlock ]	! !

!WAMutualExclusionCacheNG methodsFor: 'putting' stamp: 'pmm 9/8/2013 17:49'!
at: aKey put: anObject
	^ mutex critical: [
		cache at: aKey put: anObject ]	! !

!WAMutualExclusionCacheNG methodsFor: 'public' stamp: 'pmm 9/8/2013 17:49'!
clear
	^ mutex critical: [
		cache clear ]	! !

!WAMutualExclusionCacheNG methodsFor: 'initialization' stamp: 'pmm 9/1/2012 11:07'!
initializeOn: aCache
	self initialize.
	mutex := WAMutex new.
	cache := aCache! !

!WAMutualExclusionCacheNG methodsFor: 'accessing' stamp: 'pmm 9/8/2013 17:48'!
keyAtValue: anObject ifAbsent: aBlock
	^ mutex critical: [
		cache keyAtValue: anObject ifAbsent: aBlock ]	! !

!WAMutualExclusionCacheNG methodsFor: 'enumerating' stamp: 'pmm 9/8/2013 17:48'!
keysAndValuesDo: aTwoArgumentBlock
	^ mutex critical: [
		cache keysAndValuesDo: aTwoArgumentBlock ]	! !

!WAMutualExclusionCacheNG methodsFor: 'removing' stamp: 'pmm 9/8/2013 17:50'!
remove: anObject
	^ mutex critical: [
		cache remove: anObject ]	! !

!WAMutualExclusionCacheNG methodsFor: 'putting' stamp: 'pmm 8/26/2012 12:48'!
store: anObject
	^ mutex critical: [
		cache store: anObject ]	! !

WAObject subclass: #WACacheValueEntryNG
	instanceVariableNames: 'value valueHash key next'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Cache-NG'!
